#ifndef GAME_H
#define GAME_H

#include "Piece.h"

enum GameMode
{
    GAME_MODE_WAIT,
    GAME_MODE_PAUSED,
    GAME_MODE_PLAYING
};

#define NEXT_PIECE_COUNT 3

void Game_Init();
void Game_Deinit();

void Game_Update();
void Game_Render();

void Game_UpdateGamePieceScreenPos();
bool Game_DropGamePiece();
bool Game_GamePieceRight();
bool Game_GamePieceLeft();
bool Game_PieceRotateClockwise();
bool Game_PieceRotateCounterClockwise();
bool Game_TestGamePiece( i32 a_iX, i32 a_iY );
void Game_CreatePiece();
void Game_ApplyPiece();
void Game_RenderScore();
void Game_UpdateLevel();

extern bool g_bQuitApp;
extern Piece g_oGamePiece;
extern Piece g_oNextPiece[ NEXT_PIECE_COUNT ];
extern int g_iGamePieceX;
extern int g_iGamePieceY;
extern int g_iScore;
extern int g_iLevel;
extern int g_iLinesCleared;
extern enum GameMode g_eGameMode;
extern int g_iFrameCtr;
extern int g_iFallSpeed;

#endif
