#include "stdinc.h"

#include "font.h"
#include "Screen.h"

//system call
void sceDisplayWaitVblankStart(void);
void sceDisplaySetMode(long,long,long);
void sceDisplaySetFrameBuf(char *topaddr,long linesize,long pixelsize,long);

//variables
pixel* g_pFrontBuffer=(pixel*)0x04000000;
pixel* g_pBackBuffer=(pixel*)(0x04000000+0x44000);

void Screen_Init()
{
    sceDisplaySetMode(0,SCREEN_WIDTH,SCREEN_HEIGHT);
    sceDisplaySetFrameBuf(g_pFrontBuffer,512,1,1);
}

void Screen_Clear( pixel aiColor )
{
    Screen_FillRect( 0, 0, SCREEN_WIDTH, SCREEN_HEIGHT, aiColor );
}

void Screen_WaitV()
{
    sceDisplayWaitVblankStart();
}

void Screen_Swap()
{
    pixel* pTemp = g_pFrontBuffer;
    g_pFrontBuffer = g_pBackBuffer;
    g_pBackBuffer = pTemp;
    sceDisplaySetFrameBuf(g_pFrontBuffer,512,1,0);
}

void Screen_FillRect( int a_iX, int a_iY, int a_iWidth, int a_iHeight, pixel a_iColor )
{
    pixel* pDest = Screen_GetPoint(a_iX,a_iY);
    int iSkipPerLine = 512 - a_iWidth;

    int iRowsLeft = a_iHeight;
    while( iRowsLeft-- )
    {
        int iColsLeft = a_iWidth;
        while( iColsLeft-- )
        {
            *pDest++ = a_iColor;
        }
        pDest += iSkipPerLine;
    }
}

pixel* Screen_GetPoint( int x, int y )
{
    return g_pBackBuffer + x + (y*512) + (0x40000000>>1);
}
