#ifndef WELL_H
#define WELL_H

#include "Cell.h"

#define WELL_WIDTH 10
#define WELL_HEIGHT 16

#define WELL_SCREEN_X ((SCREEN_WIDTH>>1) - (WELL_WIDTH_PIXELS>>1))
#define WELL_SCREEN_Y ((SCREEN_HEIGHT>>1) - (WELL_HEIGHT_PIXELS>>1))

#define WELL_WIDTH_PIXELS ( WELL_WIDTH * CELL_WIDTH )
#define WELL_HEIGHT_PIXELS ( WELL_HEIGHT * CELL_HEIGHT )

extern Cell g_aWell[WELL_WIDTH][WELL_HEIGHT];

void Well_Init();
void Well_Deinit();

void Well_Render( int a_iX, int a_iY );
void Well_RenderBackground( int a_iX, int a_iY );
void Well_Update();

void Well_RemoveLine( int a_iY );
int Well_CheckForCompleteLines();

i32 Well_GetScreenX( int a_iCellX );
i32 Well_GetScreenY( int a_iCellY );

#endif 
